///^[\u4E00-\u9FA5][\da-zA-Z]{6}$/
Date.prototype.format = function(fmt)   
{ //author: meizz   
  var o = {   
    "M+" : this.getMonth()+1,                 //月份   
    "d+" : this.getDate(),                    //日   
    "h+" : this.getHours(),                   //小时   
    "m+" : this.getMinutes(),                 //分   
    "s+" : this.getSeconds(),                 //秒   
    "q+" : Math.floor((this.getMonth()+3)/3), //季度   
    "S"  : this.getMilliseconds()             //毫秒   
  };   
  if(/(y+)/.test(fmt))   
    fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));   
  for(var k in o)   
    if(new RegExp("("+ k +")").test(fmt))   
  fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));   
  return fmt;   
}  

//,fullscreen:true -- no footer
var routers = {
	'home':                {title:'物业在线',iscoll:true,back:null,cache:null,param:null,styles:['./asset/css/pagehome.css']},
	'service':             {title:'服务中心',iscoll:false,styles:['./asset/css/page.css']},
	'manage':              {title:'物业管理',iscoll:false,styles:['./asset/css/page.css']},
	'user':                {title:'用户信息',iscoll:false,styles:['./asset/css/page.css']},
	'user/about':          {title:'关于',iscoll:true,fullscreen:true,styles:['./asset/css/page.css']},
	'service/advice':      {title:'报修投诉',iscoll:true,styles:['./asset/css/pagehome.css']},
	'service/adviceDetail':{title:'报修投诉',iscoll:false,styles:['./asset/css/pagehome.css','./asset/css/page.css']},
	'service/fbgonggao':   {title:'发布公告',iscoll:true,fullscreen:true,styles:['./asset/css/page.css']},
	'service/gonggao':     {title:'小区公告',iscoll:true,styles:['./asset/css/pagegonggao.css']},
	'service/service':     {title:'物业服务',iscoll:true,styles:['./asset/css/pagehome.css']},
	'service/fbwyfw':      {title:'发布物业服务',iscoll:true,fullscreen:true,styles:['./asset/css/page.css']},
	'manage/user':         {title:'用户登录',iscoll:true,fullscreen:true,styles:['./asset/css/page.css']},
	'manage/rygl':         {title:'人员管理',iscoll:true,styles:['./asset/css/page.css']},
	'manage/cwgl':         {title:'车位管理',iscoll:true,styles:['./asset/css/page.css']},
	'manage/fkyz':         {title:'访客验证',iscoll:false,styles:['./asset/css/page.css']},
	'manage/fkyztg':       {title:'访客验证',iscoll:false,styles:['./asset/css/page.css']},
	'manage/pb':           {title:'排班',iscoll:false,styles:['./asset/css/page.css']},
	'manage/pblb':         {title:'排班',iscoll:false,styles:['./asset/css/page.css']},
	'manage/fwzs':         {title:'租售房屋',iscoll:true,styles:['./asset/css/pagehome.css']},
	'manage/fwxq':         {title:'审核房源',iscoll:true,styles:['./asset/css/page.css']},
	'manage/wyjn':         {title:'物业缴纳',iscoll:false,styles:['./asset/css/page.css']}
};
var STW = 640;
var currentRoute;
var pageready;
var domready;
var iScoll;
var _inited = false;
var init = function(t){
	if(_inited) return;
	_inited = true;
	$('#BACK').tap(function(e){
		goBack();
	});
	$('.ui-footer li').tap(function(e){
		switchMainButton(this,true);
	});
	$('#USER').tap(function(e){
		switchPage('manage/user');
	});
	$('#ADD').tap(function(e){
		if(addBtnHandler){
			addBtnHandler();
			return;
		}
		setParam(null);
		switchPage('service/fbgonggao');
	});
	$('#FERSH').tap(function(e){
		if(refreshHandler)
			refreshHandler();
	});
	//$('#CONTENT').css('height',window.innerHeight+"px");
	console.log(t);
	if(t){
		switchPage('home');
	}
	else{
		switchPage("manage/user","home");
	}
	useScoll();
	$('body').css("width","100%");
	$('body').css("height","100%");
};

function switchMainButton(dom,go){
	if($(dom).hasClass('unactive')){
		var zpts = $('.ui-footer li');
		zpts.removeClass('inactive');
		zpts.addClass('unactive');
		$(dom).addClass('inactive');
		var mainId = zpts.indexOf(dom);
		if(go)
		{
			var ru = mainId==0?'home':(mainId==1?'service':'manage');
			if(ru != currentRoute){
				switchPage(ru);
				hideFrames();
			}
		}
	}
}

function useScoll(f){
	iScoll = iScoll || new fz.Scroll('#CONTENT');
	iScoll.scrollTo(0,0);
	if(f === false)
	{
		$('#CONTENT').removeClass('iScrollWapper');
		iScoll.disable();
	}
	else{
		$('#CONTENT').addClass('iScrollWapper');
		iScoll.enable();
		setTimeout(function() {
			iScoll.refresh();
		}, 100);
	}
	//console.log('use Scroll:',f);
}

function fitScreen(){
	var sw = window.innerWidth;
	$.each($('[fs]'),function(dx,it){
		var w = $(it).data("width");
		var h = $(it).data("height");
		var rt = sw/STW;
		$(it).attr("width",w*rt);
		$(it).attr("height",h*rt);
	});
}

function hideFrames(){
	for(var dx in routers)
	{
		var rt = routers[dx];
		clearCache(rt);
	}
}

function clearCache(rt){
	delete rt.back;
	delete rt.cache;
	delete rt.param;
}

function setParam(ps){
	var rt = routers[currentRoute];
	if(rt)
	{
		rt.param = ps;
	}
}

function getParam(){
	var rt = routers[currentRoute];
	if(rt && rt.back)
	{
		rt = routers[rt.back];
		return rt.param;
	}
	return null;
}

function goBack(){
	//history.back();
	try{
		var rt = routers[currentRoute];
		currentRoute = null;
		var bck = rt.back;
		if(currentRoute == 'service/gonggao'){
			bck = "service"
		}
		switchPage(bck);
		console.log(bck);
		clearCache(rt);
	}
	catch(er){
		console.log(er);
		switchPage("home");
	}
}

function featureRight(tag,alt){
	//tag = false;
	if(!tag)
		return true;
	var u = $api.getStorage("user")||{}
	var rights = u.rights;
	if(rights){
		for(var i = 0 ; i < rights.length ; i++){
			var r = rights[i];
			if(r.id == tag){
				return r.rw;
			}
		}
	}
	if(!u.logname){
		switchPage("manage/user");
		return false;
	}
	if(alt)
		alert("您无此操作权限");
	return false;
}

var refreshHandler;
var addBtnHandler;

function switchPage(tag,bk){
	var doms;
	if(currentRoute)
	{
		var oldrouter = routers[currentRoute] || (routers[currentRoute] = {});
		var newrouter = routers[tag] || (routers[tag]={});
		if(true)
		{
			routers[currentRoute].cache = $('#scroller').children();
		}
		routers[tag].back = bk?bk:currentRoute;
	}
	else{
		doms = routers[tag].cache;
	}
	if(tag)
		currentRoute = tag;
	var crRt = routers[tag];
	var url = currentRoute;
	if(url.indexOf(".html") != url.length-6){
		url = url+".html";
	}
	pageready = null;
	if(url.indexOf('/')>0)
		$('#BACK').show();
	else
		$('#BACK').hide();
	$('#BAR_RIGHT').children().hide();
	var ulist = currentRoute.split('/');
	var title;
	$("body").removeClass("whiteBg").addClass("greyBg");
	$("#CONTENT").removeClass("whiteBg").addClass("greyBg");
	if(currentRoute == 'service' || currentRoute == 'manage' ){
		$("body").removeClass("greyBg").addClass("whiteBg");
		$("#CONTENT").removeClass("greyBg").addClass("whiteBg");
	}
	if(currentRoute == "home")
		$('#USER').show();
	$('#FERSH').hide();
	if(currentRoute == "service/gonggao")
		$('#ADD').show();
	switch(ulist[0]){
		case 'home':
		switchMainButton($('.ui-footer li')[0],false);
		break;
		case 'service':
		switchMainButton($('.ui-footer li')[1],false);
		break;
		case 'manage':
		switchMainButton($('.ui-footer li')[2],false);
		break;
	}
	if(title){
		$('#TITLE').text(title);
	}

	function forRouter(notitle){
		fitScreen();
		if(crRt)
		{
			useScoll(crRt.iscoll);
			if(crRt.fullscreen)
				$('#FOOTER').hide();
			else
				$('#FOOTER').show();
			if(crRt.title){
				if(currentRoute != 'service/advice')
					$('#TITLE').text(crRt.title);
			}
		}
	}
	$('link[autostyle]').remove();
	var styles = crRt.styles;
	if(styles != undefined && styles != null && styles.length > 0){
		for(var i=0;i<styles.length;i++){
			$('head').append('<link rel="stylesheet" type="text/css" href="' + styles[i] + '" autostyle/>');
		}
	}

	if(doms){
		console.log('cache :',url);
		$('#scroller').children().remove();
		$('#scroller').append(doms);
		forRouter();
		if(domready)domready();
	}
	else{
		$('#scroller').load("./page/"+url, function(){
			console.log('loaded :',url);
			forRouter();
			if(pageready) pageready();
		});
	}
}
var isIos7 = false;
apiready = function(){
	deviceInit();
	isIos7 = false;
    if (typeof(api)!="undefined" && api.systemType == 'ios') {
        var strSV = api.systemVersion;
        var numSV = parseInt(strSV,10);
        var fullScreen = api.fullScreen;
        var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
        if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
        	isIos7 = true;
	    	$('#HEADER').addClass('ios7');
	    	$('#CONTENT').addClass('ios7');
	    	$('#BAR_RIGHT').addClass('ios7');
	    	$('#HEADER').css('height','65px');
        }
	}
    setTimeout(function(){
    	if(typeof window.api != 'undefined')
        	api.removeLaunchView();
    }, 400);
	var u = $api.getStorage("user");
	if(u && u.logname){
		var el = $.loading({content:"加载中..."});
		function cb(ret){
			$(el).remove();
			//console.log(">>",ret);
			if(!ret || !ret.result){ 
				$api.setStorage("user",{});
				init(false);
			}
			else{
				init(true);
			}
		}
		$.apiLogin(u.logname,u.password,cb,cb);
	}
	else{
		$api.setStorage("user",{});
		init(false);
	}
	deviceAndroidKeyConf(function(){
		if(currentRoute == 'home'){
			api.confirm({
			    title: '',
			    msg: '真的要退出吗？',
			    buttons:['确定', '取消']
			},function(ret,err){
			    if(ret.buttonIndex == 1){
		            api.closeWidget({
		                id: APPID,
		                retData: {name:'closeWidget'},
		                silent:true
		            });
			    }
			});
		}
		else
			goBack();
	},function(){
		switchPage('manage/user');
	});
}

$(function(){
	if(USEDEBUG)
		apiready();
	//console.log("http://180.166.29.246:8089/appweb/app/mobile_init.xhtml?t="+(new Date).toTimeString());
});